-- Maintainer  :  Cupertino Miranda
-- Stability   :  experimental
-- Portability :  portable
--
-- Test Module for Formulas
--
-----------------------------------------------------------------------------

module Language.Gnumeric.FormulaHUnit where

import Language.Gnumeric.Formula


import HUnit
import Debug.HUnitExtras

-----------------------------------------------------------------------------

main = do
 runTestsTT
   [ testSuite "Formula Parsing"
     [ TestCase $ do assertEqual _S0 _R0 $ _F0
     , TestCase $ do assertEqual _S1 _R1 $ _F1
     , TestCase $ do assertEqual _S2 _R2 $ _F2
     , TestCase $ do assertEqual _S3 _R3 $ _F3
     , TestCase $ do assertEqual _S4 _R4 $ _F4
     , TestCase $ do assertEqual _S5 _R5 $ _F5
     , TestCase $ do assertEqual _S6 _R6 $ _F6
     ]
    ]

-----------------------------------------------------------------------------


_S0 = "Simple Constant"
_S1 = "Simple Reference"
_S2 = "Adiction of two references"
_S3 = "Function SUM"
_S4 = "Function IF with two references"
_S5 = "Function IF with a reference and a constant"
_S6 = "Reference and contant"

_F0 = parseFormula "" "" "1"
_F1 = parseFormula "" "" "=A1"
_F2 = parseFormula "" "" "=A1+A3"
_F3 = parseFormula "" "" "=SUM(A1:B6)"
_F4 = parseFormula "" "" "=IF(B1=B2, B1, B3)"
_F5 = parseFormula "" "" "=IF(B1=B2, B1, 1)"
_F6 = parseFormula "" "" "=A1+1"

_R0 = Var "1"
_R1 = Ref (CellRef {sheet = "", colNr = 0, rowNr = 0}) Nothing
_R2 = Fun "+" [Ref (CellRef {sheet = "", colNr = 0, rowNr = 0}) Nothing,Ref (CellRef {sheet = "", colNr = 0, rowNr = 2}) Nothing]
_R3 = Fun "SUM" [Ref (CellRef {sheet = "", colNr = 0, rowNr = 0}) (Just (CellRef {sheet = "", colNr = 1, rowNr = 5}))]
_R4 = Fun "IF" [Fun "=" [Ref (CellRef {sheet = "", colNr = 1, rowNr = 0}) Nothing,Ref (CellRef {sheet = "", colNr = 1, rowNr = 1}) Nothing],Ref (CellRef {sheet = "", colNr = 1, rowNr = 0}) Nothing,Ref (CellRef {sheet = "", colNr = 1, rowNr = 2}) Nothing]
_R5 = Fun "IF" [Fun "=" [Ref (CellRef {sheet = "", colNr = 1, rowNr = 0}) Nothing,Ref (CellRef {sheet = "", colNr = 1, rowNr = 1}) Nothing],Ref (CellRef {sheet = "", colNr = 1, rowNr = 0}) Nothing, Var "1"]
_R6 = Fun "+" [Ref (CellRef {sheet = "", colNr = 0, rowNr = 0}) Nothing, Var "1"]

-----------------------------------------------------------------------------

