--
-- Dim.hs -- ??
-- Owner -- ??
--

module Etc.Dim where

import Etc.BiFunctor

import Sheet.Indx
import Sheet.Sheet(Sheet,minIndx,maxIndx)

---------------------------------------------------------------------------
-- DIMENSION TYPES AND OPERATIONS
---------------------------------------------------------------------------


type Dim = (Indx,Indx)

dim :: Sheet a -> Dim
dim s = (minIndx s,maxIndx s)

inside :: Indx -> Dim -> Bool
inside (Indx c r) (Indx c1 r1,Indx c2 r2) = c>=c1 && c<=c2 && r>=r1 && r<=r2

colRng :: Sheet a -> ColRng
-- colRng s = (col a,col b) where (a,b) = dim s
colRng = mapLR col . dim

rowRng :: Sheet a -> ColRng
-- rowRng s = (row a,row b) where (a,b) = dim s
rowRng = mapLR row . dim

indxRange :: Dim -> [Indx]
indxRange (Indx c1 r1,Indx c2 r2) = [Indx c r | c <- [c1..c2], r<-[r1..r2]]

height :: Sheet a -> Row
height s = r' - r + 1 where (r,r') = rowRng s

width :: Sheet a -> Col
width s = c' - c + 1 where (c,c') = colRng s

origDim :: Indx -> Dim
origDim ix = (origin,ix)

ospan :: Col -> Row -> Dim
ospan c r = (origin,Indx c r)

-- updL :: Col -> Dim -> Dim
-- updL c (Indx _ r1,ix) = (Indx c r1,ix)
-- 
-- updR :: Col -> Dim -> Dim
-- updR c (ix,Indx c1 r1,ix) = (Indx c1 r1,Indx c r2)



