--
-- Eval.hs -- Spreadsheet evaluation
-- Owner -- Robin Abraham
--

module Etc.Eval where

import Sheet.Sheet
import Sheet.Expr
--import SpreadSheet


---------------------------------------------------------------------------
-- SPREADSHEET EVALUATION
---------------------------------------------------------------------------

-- evaluation of formulas
-- 
op :: BinOp -> (Int -> Int -> Int)
op Plus  = (+)
op Minus = (-)
op Mult  = (*)

evalF :: SheetF -> Fml -> Val
evalF _ (Inp v)  = v
evalF s (Ref ix) = maybe (E ("Ref:"++show ix)) (evalF s) (s # ix)
evalF s f@(Bin b g h) = 
                 case (evalF s g,evalF s h) of
                   (I x,I y) -> I (op b x y)
                   _         -> E (show f)
-- evalF _ f      = E ("Undef:"++show f)
-- Adding pattern for Agg
evalF s (Agg b fs) = evalF s (foldr1 (Bin b) fs) 

eval :: SheetF -> SheetV
eval s = fmap (evalF s) s



