--
-- ListUtils.hs -- List Utility Functions
-- Owner -- Martin Erwig
--

module Etc.ListUtils where

import List

-- oneDiffPos takes a list of lists of equal lengths and returns True if lists differ in exactly one position
--
oneDiffPos :: Eq a => [[a]] -> Bool
oneDiffPos = (==1) . countDiffPos


-- countDiffPos counts the number of differing positions in a list of lists
--
countDiffPos :: Eq a => [[a]] -> Int
countDiffPos = sum . map diffPos . transpose
               where diffPos xs | null (tail (nub xs)) = 0
                                | otherwise            = 1