--
-- SmartSheet.hs -- Smart spreadsheets
-- Owner -- Martin Erwig
--

-- Goal: avoid many errors through well-defined spreadsheet construction

module Etc.SmartSheet where

import Sheet.Indx
import Sheet.Sheet
-- import Dimensions.Dim
import Sheet.Expr
-- import SpreadSheet
-- import Sheet.Comb
-- import Sheet.Eval
-- import Analysis


---------------------------------------------------------------------------
-- EXAMPLES
---------------------------------------------------------------------------

-- address/indexing functions
--
cols@[a,b,c] = map Indx [1..3]
refs@[ra,rb,rc] = map (Ref .) cols

s :: SheetF
s = Sheet
    [(a 1,i 3), 
     (a 2,Bin Plus (ra 1) (i 2)),
     (b 1,ra 2),
     (b 2,Bin Plus (ra 3) (i 3)),
     (c 1,u),
     (c 3,Ref (Indx 9 9))]


-- example spreadsheets/tables
--
s' :: SheetV
s' = eval s

ab = Sheet [(a 1,i 3),(b 1,i 5)]

a2 = Sheet [(a 1,i 7),(a 2,i 11)]

nest = Sheet [(a 1,i 7),(b 1, Abs ab origin),
              (a 2,Abs a2 origin),(b 2,i 9)]


natR n = right (mapIF succ) n (unitIF 1)
natD n = down (mapIF succ) n (unitIF 1)

binTable :: BinOp -> Col -> Row -> SheetF
binTable b c r = top <-> (border <|> body)
                     where top    = unitSF (show b) <|> natR c
                           border = natD r
                           body   = table (tabulate b) (ospan c r)

at99 = eval (binTable Plus 9 9)
mt99 = eval (binTable Mult 9 9)



