
module Inputs where
--
-- Inputs.hs -- Test code for UCheck
-- Owner -- N/A
--

--
-- Example
--

{-
    A      B      C     D       E
1        Fruit
2  Month Apple   Orange Plum    Total 
3    May     8     11    21     *  
4   June    75     5     15     /
5   July    30     @B3   30     +
6    @D2   SUM    SUM  SUM      @Z9
7          @C3    

-}

cols@[a,b,c,d,e] = map Indx [1..5]
refs@[ra,rb,rc,rd,re,rf] = map (Ref .) cols

harvest :: SheetF
harvest = Sheet [(b 1,is "Fruit"), 
                 (a 2,is "Month"),(b 2,is "Apple"),(c 2,is "Orange"),(d 2,is "Plum"),(e 2,is "Total"), 
                 (a 3,is "May"),(b 3,ii 8),(c 3,ii 11),(d 3,ii 21),(e 3,agg Mult [b 3,c 3,d 3]),
                 (a 4,is "June"),(b 4,ii 75),(c 4,ii 5),(d 4,ii 15),(e 4,agg Plus [b 4,c 4,d 4]),
                 (a 5,is "July"),(b 5,ii 30),(c 5,Ref (b 3)),(d 5,ii 30),(e 5,agg Plus [b 5,c 5,d 5]),
                 (a 6,Ref (d 2)),(b 6,agg Plus [b 3,b 4,b 5]),(c 6,agg Plus [c 3,c 4,c 5]),(d 6,agg Plus [d 3,d 4,d 5]),
                 (b 7,Ref (c 3))
          ]

-- for testing ...
--Sheet h = harvest 

--result :: SheetV
--result = eval harvest

-- not needed yet ...
-- harvestTypeA = []

-- information about headers gathered from the user
-- 
harvestHeaders = [(b 1,[]),(b 2,[b 1]),(c 2,[b 1]),(d 2,[b 1]),
                  (a 2,[]),(a 3,[a 2]),(a 4,[a 2]),(a 5,[a 2]),
                  (b 3,[a 3,b 2]),(c 3,[a 3,c 2]),(d 3,[a 3,d 2]),
                  (b 4,[a 4,b 2]),(c 4,[a 4,c 2]),(d 4,[a 4,d 2]),
                  (b 5,[a 5,b 2]),(c 5,[a 5,c 2]),(d 5,[a 5,d 2])]

-- ** Uncomment for testing
units :: SheetU
units = inferU harvestHeaders harvest
-- sunits = simpfy units harvestHeaders harvest

-- we only have a form of weak subject reduction:
-- 
--unitsR :: SheetU
--unitsR = inferU harvestHeaders (lift result)

