module UCheck.Test.UnitsTest where

import Sheet.Expr
import UCheck.FaultLoc
import UCheck.HdrAux
import UCheck.HdrDef
import Sheet.Indx
import Sheet.Sheet
import UCheck.Units
import UCheck.UnitErrors

import List
import Maybe

ii = Inp . I
is = Inp . S
ie = Inp . E
iu = Inp Unused

agg :: BinOp -> [Indx] -> Fml
agg op ind = Agg op (map Ref ind)

cols@[a,b,c,d,e,f,g,h] = map Indx [1..8]

sf = drpSht rngTooSmlErrSheet1
si = Indx 5 3
si2 = Indx 7 7
stt = addRefToIndx sf si si2
stt2 = remRefFromIndx stt si si2

----- NOT BEING USED (BEGIN) -----

{-

getIndx:: Unit -> SheetU -> Indx
getIndx u s = fst $ fromMaybe (a 0,U [[["Error"]]]) (find (\(idx,u') -> u == u') (drop' s))

-}

----- NOT BEING USED (END) -----

----- SCOTT'S TEST CODE (BEGIN) -----

stmu = [[["Class","Senior, 2004"],["District","Adrian"]],[["Class","Junior, 2003"],["District","Adrian"]],[["Class","Junior, 2003"],["District","Baker"]]]
st = [["Class","Senior, 2004"],["District","Adrian"]]
st2 = [["Class","Junior, 2003"],["District","Adrian"]]
st3 = [["Class","Junior, 2003"],["District","Baker"]]

sc = getCmnDepUnts [st,st2]

soub = [[["Fruit","Apple"],["Month","July"]],[["Month","May"],["Fruit","Apple"]],[["Month","June"],["Fruit","Apple"]]]
souc = [[["Fruit","Orange"],["Month","July"]]]
soud = [[["Fruit","Plum"],["Month","July"]],[["Month","May"],["Fruit","Plum"]],[["Month","June"],["Fruit","Plum"]]]

miu = [(c 3,[["Fruit","Orange"],["Month","May"]]),(c 4,[["Fruit","Orange"],["Month","June"]])]
seru = [(b 6,soub),(c 6,souc),(d 6,soud)]

u1 = [["Fruit","Apple"],["City","Port"],["Month","July"]]
u2 = [["Month","May"],["Fruit","Apple"],["City","Port"]]

--saf = map (\x->(head (fst (unzip x)),snd (unzip x))) (groupBy (\(x,y) (x',y')->x == x') (sort saf2))
--saf2 = concatMap (\(x,y,z)->if z then [(x,y)] else []) saf3
--saf3 = concatMap (\(i,au)->map (\(i',ou)->if length ou > 1 then (i',i,intersect au (getCmnDepUnts ou) == (getCmnDepUnts ou)) else (i',i,tmpTst ou au)) seru) miu





{-
st = case (getUnitFromIndx (drpUntSht (inferU hdrs validSheet)) (Indx 3 3)) of
        Just u  -> u
        Nothing -> oneUnit

st2 = case (getUnitFromIndx (drpUntSht (inferU hdrs validSheet)) (Indx 3 4)) of
         Just u  -> u
         Nothing -> oneUnit

du = head (head (drpUnt st))
du2 = head (head (drpUnt st2))
au = head (drpUnt st)

stt = case (getUnitFromIndx (drpUntSht (inferU hdrs validSheet)) (Indx 5 3)) of
         Just u  -> u
         Nothing -> oneUnit

getDepUnitsFromUnit :: Unit -> [DepUnit]
getDepUnitsFromUnit (U u) = head u

-- only checking if one round has all the same dep units...need to check all round but one do...
havComDepUntInAll :: Unit -> [DepUnit] -> Bool
havComDepUntInAll u au = (allHavDepUnt u (head au)) || (havComDepUntInAll u (tail au))

allHavDepUnt :: Unit -> DepUnit -> Bool
allHavDepUnt (U [[[]]]) _ = False
allHavDepUnt (U [au]) du = andUntContDepUnt au du
allHavDepUnt (U u) du = (andUntContDepUnt (head u) du) && (allHavDepUnt (U (tail u)) du)

andUntContDepUnt :: AndUnit -> DepUnit -> Bool
andUntContDepUnt au du = case (find (==du) au) of
                      Just _  -> True
                      Nothing -> False
-}

{-

problems:
 - c4's formula = reference to self (c4) -- doesn't terminate
 - c4's formula = reference to c5 -- throws an exception

notes:
 - getFml :: Indx -> Sheet Fml -> Fml

-}

-- gets the formula at the passed cell for the given sheet
--t1 = getFml (b 3) validSheet

-- infers the units for the valid sheet
inferT1 = inferU hdrs validSheet -- currently all units are being "or"ed

-- infers the units for cell b3 in the valid sheet
--inferT2 = inferT2Hlp validSheet hdrs ((b 3),(getFml (b 3) validSheet)) -- currently all units are being "or"ed
--inferT2Hlp :: Sheet Fml -> Headers -> Cell Fml -> Unit
--inferT2Hlp (Sheet cs) hs fml = inferUC cs hs fml

inferT3 :: Sheet Fml -> Headers -> Indx -> Unit
inferT3 sht hs idx = inferT3Hlp sht hs idx -- currently all units are being "or"ed
inferT3Hlp :: Sheet Fml -> Headers -> Indx -> Unit
inferT3Hlp (Sheet cs) hs fml = getUnit cs hs fml

smplT1 = map (\x -> 3 * x + 4) [1 .. 10]

--------------------------------------------------
--------------------------------------------------
--------------------------------------------------

-- valid or units
--
vOr1 = [[["Fruit","Apple"],["Month","May"]],[["Fruit","Apple"],["Month","June"]]]
vOr2 = [[["Fruit","Apple"],["Month","May"],["State","Oregon"]],[["Fruit","Apple"],["Month","May"],["State","Washington"]]]
vOr3 = [[["Fruit","Apple"],["Month","May"]],[["Fruit","Apple"],["Month","Apple"]]]
vOr4 = [[["Fruit","Apple"],["Month","May"]],[["Fruit","Apple"],["Month","June"]],[["Fruit","Orange"],["Month","May"]],[["Fruit","Orange"],["Month","June"]]]

-- invalid or units
--
ivOr1 = [[["Fruit","Apple"],["Month","May"]],[["Fruit","Orange"],["Month","June"]]]
ivOr2 = [[["Fruit","Apple"],["Month","May"],["State","Oregon"]],[["Fruit","Apple"],["Month","June"],["State","Washington"]]]

-- valid and units
--
vAnd1 = [["Fruit","Apple"],["Month","May"]]
vAnd2 = [["Fruit","Apple"],["Month","May"],["State","Oregon"]]
vAnd3 = [["Fruit","Apple"],["Month","May"],["State","Apple"]]

-- invalid and units
--
ivAnd1 = [["Fruit","Apple"],["Fruit","Orange"]]
ivAnd2 = [["Fruit","Apple"],["Month","May"],["Fruit","Orange"]]

--runValidOrFuncTests :: [Bool]
--runValidOrFuncTests = map validOr [vOr1,vOr2,vOr3,vOr4,ivOr1,ivOr2]

--runValidAndFuncTests :: [Bool]
--runValidAndFuncTests = map validAnd [vAnd1,vAnd2,vAnd3,ivAnd1,ivAnd2]

--------------------------------------------------
--------------------------------------------------
--------------------------------------------------

{-
	A		B
1			Fruit
2	Month		4
-}

hdrs1 :: Headers
hdrs1 = [(b 1, []),
         (a 2, []), (b 2, [a 2, b 1])]

validSheet1 :: Sheet Fml
validSheet1 = Sheet [(b 1, is "Fruit"),
                    (a 2, is "Month"), (b 2, ii 4)]

inferUT1 = inferU hdrs1 validSheet1

inferUCT1 = inferUC [(b 1, is "Fruit"), (a 2, is "Month"), (b 2, ii 4)] hdrs1 (b 2, ii 4)

getUnitT1 = getUnit [(b 1, is "Fruit"), (a 2, is "Month"), (b 2, ii 4)] hdrs1 (b 2)

--------------------------------------------------
--------------------------------------------------
--------------------------------------------------

{-
	A		B
1			Fruit
2	Month	Apple
3	May		4
-}

hdrs2 :: Headers
hdrs2 = [(b 1, []),
         (a 2, []), (b 2, [b 1]),
         (a 3, [a 2]), (b 3, [a 3, b 2])]

validSheet2 :: Sheet Fml
validSheet2 = Sheet [(b 1, is "Fruit"),
                     (a 2, is "Month"), (b 2, is "Apple"),
                     (a 3, is "May"), (b 3, ii 4)]

inferUT2 = inferU hdrs2 validSheet2

--------------------------------------------------
--------------------------------------------------
--------------------------------------------------

{-
	A		B
1			Fruit
2	Month		Apple
3	May		4
4	June		5
5	Total		=SUM(B3:B4)
-}

hdrs3 :: Headers
hdrs3 = [(b 1, []),
         (a 2, []), (b 2, [b 1]),
         (a 3, [a 2]), (b 3, [a 3, b 2]),
         (a 4, [a 2]), (b 4, [a 4, b 2])]

validSheet3 :: Sheet Fml
validSheet3 = Sheet [(b 1, is "Fruit"),
                     (a 2, is "Month"), (b 2, is "Apple"),
                     (a 3, is "May"), (b 3, ii 4),
                     (a 4, is "June"), (b 4, ii 5),
                     (a 5, is "Total"), (b 5, agg Plus [b 3, b 4])]

inferUT3 = inferU hdrs3 validSheet3

--------------------------------------------------
--------------------------------------------------
--------------------------------------------------

{-
	A		B		C		D		E
1			Fruit
2	Month	Apple	Orange	Plum	Total
3	May		4		5		6		=SUM(B3:D3)
4	June	7		7		8		=SUM(B4:D4)
5	July	5		5		4		=SUM(B5:D5)
6	Total	=SUM(B3:B5)	=SUM(C3:C5)	=SUM(D3:D5)	=SUM(E3:E5)
-}

simpHdrs :: Headers
simpHdrs = [(b 1, []), (b 2, [b 1]), (c 2, [b 1]), (d 2, [b 1]),
            (a 2, []), (a 3, [a 2]), (a 4, [a 2]), (a 5, [a 2]),
            (b 3, [a 3, b 2]), (c 3, [a 3, c 2]), (d 3, [a 3, d 2]),
            (b 4, [a 4, b 2]), (c 4, [a 4, c 2]), (d 4, [a 4, d 2]),
            (b 5, [a 5, b 2]), (c 5, [a 5, c 2]), (d 5, [a 5,d 2])]

-- range-too-small error in c6 formula
simpRngTooSmlErrSheet :: Sheet Fml
simpRngTooSmlErrSheet = Sheet [(b 1, is "Fruit"),
                               (a 2, is "Month"), (b 2, is "Apple"), (c 2, is "Orange"), (d 2, is "Plum"), (e 2, is "Total"),
                               (a 3, is "May"), (b 3, ii 4), (c 3, ii 5), (d 3, ii 6), (e 3, agg Plus [b 3, c 3, d 3]),
                               (a 4, is "June"), (b 4, ii 7), (c 4, ii 7), (d 4, ii 8), (e 4, agg Plus [b 4, c 4, d 4]),
                               (a 5, is "July"), (b 5, ii 5), (c 5, ii 5), (d 5, ii 4), (e 5, agg Plus [b 5, c 5, d 5]),
                               (a 6, is "Total"), (b 6, agg Plus [b 3, b 4, b 5]), (c 6, agg Plus [c 4, c 5]), (d 6, agg Plus [d 3, d 4, d 5]), (e 6, agg Plus [b 6, c 6, d 6])]
                               
inferURngErr = inferU simpHdrs simpRngTooSmlErrSheet

testA = unitChecker inferURngErr inferURngErr simpHdrs simpRngTooSmlErrSheet

testB = refineErrs testA
-- [Cell Unit] -> Headers -> [Cell Fml] -> OrUnit -> ErrDesc
testC = validOr (unSheet inferURngErr) simpHdrs (unSheet simpRngTooSmlErrSheet) (unU $ fromJust $ inferURngErr#(Indx 5 6))

-- writ <- send sock (unitMsg (unSheet $ faultLoc sheet (refineErrs ())))

--------------------------------------------------
--------------------------------------------------
--------------------------------------------------

{-
	A		B		C		D
1			Fruit
2	Month		Apple		Orange		Total
3	May		4		6		=SUM(B3:C3)
4	June		5		7		=SUM(B4:C4)
5	Total		=SUM(B3:B4)	=SUM(C3:C4)	=SUM(B5:C5)
-}

hdrs4 :: Headers
hdrs4 = [(b 1, []),
         (a 2, []), (b 2, [b 1]), (c 2, [b 1]),
         (a 3, [a 2]), (b 3, [a 3, b 2]), (c 3, [a 3, c 2]),
         (a 4, [a 2]), (b 4, [a 4, b 2]), (c 4, [a 4, c 2])]

validSheet4 :: Sheet Fml
validSheet4 = Sheet [(b 1, is "Fruit"),
                     (a 2, is "Month"), (b 2, is "Apple"), (c 2, is "Orange"), (d 2, is "Total"),
                     (a 3, is "May"), (b 3, ii 4), (c 3, ii 6), (d 3, agg Plus [b 3, c 3]),
                     (a 4, is "June"), (b 4, ii 5), (c 4, ii 7), (d 4, agg Plus [b 4, c 4]),
                     (a 5, is "Total"), (b 5, agg Plus [b 3, b 4]), (c 5, agg Plus [c 3, c 4]), (d 5, agg Plus [b 5, c 5])]

inferUT4 = inferU hdrs4 validSheet4

--------------------------------------------------
--------------------------------------------------
--------------------------------------------------

{-
runTests :: [Bool] -- bool indicates if an error was found or not
runTests = [not (null (unitChecker (inferU hdrs validSheet))),
            not (null (unitChecker (inferU hdrs rngTooSmlErrSheet1))),
            not (null (unitChecker (inferU hdrs rngTooLrgErrSheet))),
            not (null (unitChecker (inferU hdrs rngOffErrSheet))),
            not (null (unitChecker (inferU hdrs unExtRefErrSheet))),
            not (null (unitChecker (inferU hdrs refErrSheet))),
            not (null (unitChecker (inferU hdrs omErrSheet)))]
-}

{-
	A		B		C		D		E
1			Fruit
2	Month		Apple		Orange		Plum		Total
3	May		4		5		6		=SUM(B3:D3)
4	June		7		7		8		=SUM(B4:D4)
5	July		5		5		4		=SUM(B5:D5)
6	Total		=SUM(B3:B5)	=SUM(C3:C5)	=SUM(D3:D5)	=SUM(E3:E5)
-}

hdrs :: Headers
hdrs = [(b 2,[b 1]),(c 2,[b 1]),(d 2,[b 1]),(e 2,[b 1]),
        (a 3,[a 2]),(b 3,[a 3,b 2]),(c 3,[a 3,c 2]),(d 3,[a 3,d 2]),(e 3,[a 3,e 2]),
        (a 4,[a 2]),(b 4,[a 4,b 2]),(c 4,[a 4,c 2]),(d 4,[a 4,d 2]),(e 4,[a 4,e 2]),
        (a 5,[a 2]),(b 5,[a 5,b 2]),(c 5,[a 5,c 2]),(d 5,[a 5,d 2]),(e 5,[a 5,e 2]),
        (a 6,[a 2]),(b 6,[a 6,b 2]),(c 6,[a 6,c 2]),(d 6,[a 6,d 2]),(e 6,[a 6,e 2])]

validSheet :: Sheet Fml
validSheet = Sheet [(b 1, is "Fruit"),
                    (a 2, is "Month"), (b 2, is "Apple"), (c 2, is "Orange"), (d 2, is "Plum"), (e 2, is "Total"),
                    (a 3, is "May"), (b 3, ii 4), (c 3, ii 5), (d 3, ii 6), (e 3, agg Plus [b 3, c 3, d 3]),
                    (a 4, is "June"), (b 4, ii 7), (c 4, ii 7), (d 4, ii 8), (e 4, agg Plus [b 4, c 4, d 4]),
                    (a 5, is "July"), (b 5, ii 5), (c 5, ii 5), (d 5, ii 4), (e 5, agg Plus [b 5, c 5, d 5]),
                    (a 6, is "Total"), (b 6, agg Plus [b 3, b 4, b 5]), (c 6, agg Plus [c 3, c 4, c 5]), (d 6, agg Plus [d 3, d 4, d 5]), (e 6, agg Plus [e 3, e 4, e 5])]

----- range-too-small error in c6 formula
rngTooSmlErrSheet1 :: Sheet Fml
rngTooSmlErrSheet1 = Sheet [(b 1, is "Fruit"),
                            (a 2, is "Month"), (b 2, is "Apple"), (c 2, is "Orange"), (d 2, is "Plum"), (e 2, is "Total"),
                            (a 3, is "May"), (b 3, ii 4), (c 3, ii 5), (d 3, ii 6), (e 3, agg Plus [b 3, c 3, d 3]),
                            (a 4, is "June"), (b 4, ii 7), (c 4, ii 7), (d 4, ii 8), (e 4, agg Plus [b 4, c 4, d 4]),
                            (a 5, is "July"), (b 5, ii 5), (c 5, ii 5), (d 5, ii 4), (e 5, agg Plus [b 5, c 5, d 5]),
                            (a 6, is "Total"), (b 6, agg Plus [b 3, b 4, b 5]), (c 6, agg Plus [c 4, c 5]), (d 6, agg Plus [d 3, d 4, d 5]), (e 6, agg Plus [b 6, c 6, d 6])]

rngTooSmlErrSheet2 :: Sheet Fml
rngTooSmlErrSheet2 = Sheet [(b 1, is "Fruit"),
                            (a 2, is "Month"), (b 2, is "Apple"), (c 2, is "Orange"), (d 2, is "Plum"), (e 2, is "Total"),
                            (a 3, is "May"), (b 3, ii 4), (c 3, ii 5), (d 3, ii 6), (e 3, agg Plus [b 3, c 3, d 3]),
                            (a 4, is "June"), (b 4, ii 7), (c 4, ii 7), (d 4, ii 8), (e 4, agg Plus [b 4, c 4, d 4]),
                            (a 5, is "July"), (b 5, ii 5), (c 5, ii 5), (d 5, ii 4), (e 5, agg Plus [b 5, c 5, d 5]),
                            (a 6, is "Total"), (b 6, agg Plus [b 3, b 4, b 5]), (c 6, agg Plus [c 4, c 5]), (d 6, agg Plus [d 3, d 4, d 5]), (e 6, agg Plus [e 3, e 4, e 5])]

----- range-too-large error in b6 formula
rngTooLrgErrSheet :: Sheet Fml
rngTooLrgErrSheet = Sheet [(b 1, is "Fruit"),
                           (a 2, is "Month"), (b 2, is "Apple"), (c 2, is "Orange"), (d 2, is "Plum"), (e 2, is "Total"),
                           (a 3, is "May"), (b 3, ii 4), (c 3, ii 5), (d 3, ii 6), (e 3, agg Plus [b 3, c 3, d 3]),
                           (a 4, is "June"), (b 4, ii 7), (c 4, ii 7), (d 4, ii 8), (e 4, agg Plus [b 4, c 4, d 4]),
                           (a 5, is "July"), (b 5, ii 5), (c 5, ii 5), (d 5, ii 4), (e 5, agg Plus [b 5, c 5, d 5]),
                           (a 6, is "Total"), (b 6, agg Plus [b 1, b 2, b 3, b 4, b 5]), (c 6, agg Plus [c 3, c 4, c 5]), (d 6, agg Plus [d 3, d 4, d 5]), (e 6, agg Plus [b 6, c 6, d 6])]

----- range-offset error in c6 formula
rngOffErrSheet :: Sheet Fml
rngOffErrSheet = Sheet [(b 1, is "Fruit"),
                        (a 2, is "Month"), (b 2, is "Apple"), (c 2, is "Orange"), (d 2, is "Plum"), (e 2, is "Total"),
                        (a 3, is "May"), (b 3, ii 4), (c 3, ii 5), (d 3, ii 6), (e 3, agg Plus [b 3, c 3, d 3]),
                        (a 4, is "June"), (b 4, ii 7), (c 4, ii 7), (d 4, ii 8), (e 4, agg Plus [b 4, c 4, d 4]),
                        (a 5, is "July"), (b 5, ii 5), (c 5, ii 5), (d 5, ii 4), (e 5, agg Plus [b 5, c 5, d 5]),
                        (a 6, is "Total"), (b 6, agg Plus [b 3, b 4, b 5]), (c 6, agg Plus [c 2, c 3, c 4]), (d 6, agg Plus [d 3, d 4, d 5]), (e 6, agg Plus [e 3, e 4, e 5])]

----- unexpected-extra-reference error in c6 formula
unExtRefErrSheet :: Sheet Fml
unExtRefErrSheet = Sheet [(b 1, is "Fruit"),
                          (a 2, is "Month"), (b 2, is "Apple"), (c 2, is "Orange"), (d 2, is "Plum"), (e 2, is "Total"),
                          (a 3, is "May"), (b 3, ii 4), (c 3, ii 5), (d 3, ii 6), (e 3, agg Plus [b 3, c 3, d 3]),
                          (a 4, is "June"), (b 4, ii 7), (c 4, ii 7), (d 4, ii 8), (e 4, agg Plus [b 4, c 4, d 4]),
                          (a 5, is "July"), (b 5, ii 5), (c 5, ii 5), (d 5, ii 4), (e 5, agg Plus [b 5, c 5, d 5]),
                          (a 6, is "Total"), (b 6, agg Plus [b 3, b 4, b 5]), (c 6, agg Plus [b 3, b 4, b 5]), (d 6, agg Plus [d 3, d 4, d 5]), (e 6, agg Plus [e 3, e 4, e 5])]

----- reference error in b4 formula
refErrSheet :: Sheet Fml
refErrSheet = Sheet [(b 1, is "Fruit"),
                     (a 2, is "Month"), (b 2, is "Apple"), (c 2, is "Orange"), (d 2, is "Plum"), (e 2, is "Total"),
                     (a 3, is "May"), (b 3, ii 4), (c 3, ii 5), (d 3, ii 6), (e 3, agg Plus [b 3, c 3, d 3]),
                     (a 4, is "June"), (b 4, Ref (c 3)), (c 4, ii 6), (d 4, ii 8), (e 4, agg Plus [b 4, c 4, d 4]),
                     (a 5, is "July"), (b 5, ii 5), (c 5, ii 5), (d 5, ii 4), (e 5, agg Plus [b 5, c 5, d 5]),
                     (a 6, is "Total"), (b 6, agg Plus [b 3, b 4, b 5]), (c 6, agg Plus [c 3, c 4, c 5]), (d 6, agg Plus [d 3, d 4, d 5]), (e 6, agg Plus [e 3, e 4, e 5])]

----- reference error in b4 formula
refErrSheet2 :: Sheet Fml
refErrSheet2 = Sheet [(b 1, is "Fruit"),
                      (a 2, is "Month"), (b 2, is "Apple"), (c 2, is "Orange"), (d 2, is "Plum"), (e 2, is "Total"),
                      (a 3, is "May"), (b 3, ii 4), (c 3, ii 5), (d 3, ii 6), (e 3, Outer (Agg Plus [RefRng [Ref (b 3), Ref (c 3), Ref (d 3)]])),
                      (a 4, is "June"), (b 4, Outer (Ref (c 3))), (c 4, ii 6), (d 4, ii 8), (e 4, Outer (Agg Plus [RefRng [Ref (b 4), Ref (c 4), Ref (d 4)]])),
                      (a 5, is "July"), (b 5, ii 5), (c 5, ii 5), (d 5, ii 4), (e 5, Outer (Agg Plus [RefRng [Ref (b 5), Ref (c 5), Ref (d 5)]])),
                      (a 6, is "Total"), (b 6, Outer (Agg Plus [RefRng [Ref (b 3), Ref (b 4), Ref (b 5)]])), (c 6, Outer (Agg Plus [RefRng [Ref (c 3), Ref (c 4), Ref (c 5)]])), (d 6, Outer (Agg Plus [RefRng [Ref (d 3), Ref (d 4), Ref (d 5)]])), (e 6, Outer (Agg Plus [RefRng [Ref (e 3), Ref (e 4), Ref (e 5)]]))]

----- reference error in b4 formula
refErrSheet3 :: Sheet Fml
refErrSheet3 = Sheet [(b 1, is "Fruit"),
                      (a 2, is "Month"), (b 2, is "Apple"), (c 2, is "Orange"), (d 2, is "Plum"), (e 2, is "Total"),
                      (a 3, is "May"), (b 3, ii 4), (c 3, ii 5), (d 3, ii 6), (e 3, Agg Plus [RefRng [Ref (b 3), Ref (c 3), Ref (d 3)]]),
                      (a 4, is "June"), (b 4, Ref (c 3)), (c 4, ii 6), (d 4, ii 8), (e 4, Agg Plus [RefRng [Ref (b 4), Ref (c 4), Ref (d 4)]]),
                      (a 5, is "July"), (b 5, ii 5), (c 5, ii 5), (d 5, ii 4), (e 5, Agg Plus [RefRng [Ref (b 5), Ref (c 5), Ref (d 5)]]),
                      (a 6, is "Total"), (b 6, Agg Plus [RefRng [Ref (b 3), Ref (b 4), Ref (b 5)]]), (c 6, Agg Plus [RefRng [Ref (c 3), Ref (c 4), Ref (c 5)]]), (d 6, Agg Plus [RefRng [Ref (d 3), Ref (d 4), Ref (d 5)]]), (e 6, Agg Plus [RefRng [Ref (e 3), Ref (e 4), Ref (e 5)]])]

----- omission error in c6 formula (c4 is left blank)
omErrSheet :: Sheet Fml
omErrSheet = Sheet [(b 1, is "Fruit"),
                   (a 2, is "Month"), (b 2, is "Apple"), (c 2, is "Orange"), (d 2, is "Plum"), (e 2, is "Total"),
                   (a 3, is "May"), (b 3, ii 4), (c 3, ii 5), (d 3, ii 6), (e 3, agg Plus [b 3, c 3, d 3]),
                   (a 4, is "June"), (b 4, ii 7), (d 4, ii 8), (e 4, agg Plus [b 4, c 4, d 4]),
                   (a 5, is "July"), (b 5, ii 5), (c 5, ii 5), (d 5, ii 4), (e 5, agg Plus [b 5, c 5, d 5]),
                   (a 6, is "Total"), (b 6, agg Plus [b 3, b 4, b 5]), (c 6, agg Plus [c 3, c 4, c 5]), (d 6, agg Plus [d 3, d 4, d 5]), (e 6, agg Plus [e 3, e 4, e 5])]

enrlShtHdrs :: Headers
enrlShtHdrs = [(b 2, [b 1]), (c 2, [b 1]), (d 2, [b 1]), (e 2, [b 1]), (f 2, [b 1]), (g 2, [b 1]), (h 2, [b 1]),
               (a 3, [a 2]), (b 3, [b 2, a 3]), (c 3, [c 2, a 3]), (d 3, [d 2, a 3]), (e 3, [e 2, a 3]), (f 3, [f 2, a 3]), (g 3, [g 2, a 3]), (h 3, [h 2, a 3]),
               (a 4, [a 2]), (b 4, [b 2, a 4]), (c 4, [c 2, a 4]), (d 4, [d 2, a 4]), (e 4, [e 2, a 4]), (f 4, [f 2, a 4]), (g 4, [g 2, a 4]), (h 4, [h 2, a 4]),
               (a 5, [a 2]), (b 5, [b 2, a 5]), (c 5, [c 2, a 5]), (d 5, [d 2, a 5]), (e 5, [e 2, a 5]), (f 5, [f 2, a 5]), (g 5, [g 2, a 5]), (h 5, [h 2, a 5]),
               (a 6, [a 2]), (b 6, [b 2, a 6]), (c 6, [c 2, a 6]), (d 6, [d 2, a 6]), (e 6, [e 2, a 6]), (f 6, [f 2, a 6]), (g 6, [g 2, a 6]), (h 6, [h 2, a 6]),
               (a 7, [a 2]), (b 7, [b 2, a 7]), (c 7, [c 2, a 7]), (d 7, [d 2, a 7]), (e 7, [e 2, a 7]), (f 7, [f 2, a 7]), (g 7, [g 2, a 7]), (h 7, [h 2, a 7]),
               (a 8, [a 2]), (b 8, [b 2, a 8]), (c 8, [c 2, a 8]), (d 8, [d 2, a 8]), (e 8, [e 2, a 8]), (f 8, [f 2, a 8]), (g 8, [g 2, a 8]), (h 8, [h 2, a 8]),
               (a 9, [a 2]), (b 9, [b 2, a 9]), (c 9, [c 2, a 9]), (d 9, [d 2, a 9]), (e 9, [e 2, a 9]), (f 9, [f 2, a 9]), (g 9, [g 2, a 9]), (h 9, [h 2, a 9]),
               (a 10, [a 2]), (b 10, [b 2, a 10]), (c 10, [c 2, a 10]), (d 10, [d 2, a 10]), (e 10, [e 2, a 10]), (f 10, [f 2, a 10]), (g 10, [g 2, a 10]), (h 10, [h 2, a 10])]

enrlSht :: Sheet Fml
enrlSht = Sheet [(b 1, is "District"),
                 (a 2, is "Class"), (b 2, is "Adrian"), (c 2, is "Amity"), (d 2, is "Baker"), (e 2, is "Beaverton"), (f 2, is "Bend"), (g 2, is "Cascade"), (h 2, is "Total"),
                 (a 3, is "Senior, 2004"), (b 3, ii 20), (c 3, ii 23), (d 3, ii 18), (e 3, ii 17), (f 3, ii 15), (g 3, ii 17), (h 3, agg Plus [b 3, c 3, d 3, e 3, f 3, g 3]),
                 (a 4, is "Junior, 2004"), (b 4, ii 22), (c 4, ii 22), (d 4, ii 16), (e 4, ii 23), (f 4, ii 12), (g 4, ii 18), (h 4, agg Plus [b 4, c 4, d 4, e 4, f 4, g 4]),
                 (a 5, is "Senior, 2003"), (b 5, Ref (c 4)), (c 5, ii 12), (d 5, ii 17), (e 5, ii 20), (f 5, ii 16), (g 5, ii 17), (h 5, agg Plus [b 5, c 5, d 5, e 5, f 5, g 5]),
                 (a 6, is "Junior, 2003"), (b 6, ii 16), (c 6, ii 17), (d 6, ii 18), (e 6, ii 22), (f 6, ii 17), (g 6, ii 20), (h 6, agg Plus [b 6, c 6, d 6, e 6, f 6, g 6]),
                 (a 7, is "Senior, 2002"), (b 7, ii 23), (c 7, ii 12), (d 7, ii 16), (e 7, ii 17), (f 7, ii 14), (g 7, ii 19), (h 7, agg Plus [b 7, c 7, d 7, e 7, f 7, g 7]),
                 (a 8, is "Junior, 2002"), (b 8, ii 22), (c 8, ii 20), (d 8, ii 20), (e 8, ii 21), (f 8, ii 18), (g 8, ii 21), (h 8, agg Plus [b 8, c 8, d 8, e 8, f 8, g 8]),
                 (a 9, is "Seniors"), (b 9, agg Plus [b 3, b 5, b 7]), (c 9, agg Plus [c 3, c 5, c 7]), (d 9, agg Plus [d 3, d 5, d 7]), (e 9, agg Plus [e 3, e 6, e 7]), (f 9, agg Plus [f 3, f 5, f 7]), (g 9, agg Plus [g 3, g 5, g 7]), (h 9, agg Plus [b 9, c 9, d 9, e 9, f 9, g 9]),
                 (a 10, is "Juniors"), (b 10, agg Plus [b 4, b 6, b 8]), (c 10, agg Plus [c 2, c 4, c 6, c 8]), (d 10, agg Plus [d 4, d 6, d 8]), (e 10, agg Plus [e 4, e 6, e 8]), (f 10, agg Plus [f 6, f 7, f 8]), (g 10, agg Plus [g 4, g 6, g 8]), (h 9, agg Plus [b 10, c 10, d 10, e 10, f 10, g 10])]

popSheet :: Sheet Fml -> [(Indx,Fml)]
popSheet (Sheet cs) = cs

--------------------------------------------------
--------------------------------------------------
--------------------------------------------------
{-
checkOmErr :: Sheet Fml -> [Indx] -> [Indx]
checkOmErr fs is = checkForms (zip (getInvolvedIndicesFromErrIndices fs is) (convIndicesToFormulas fs (getInvolvedIndicesFromErrIndices fs is)))

checkForms :: [(Indx,Fml)] -> [Indx]
checkForms [] = []
checkForms ((i,f):xs) =
	if (formulaIsOm f) then
		[i]
	else
		checkForms xs

convIndicesToFormulas :: Sheet Fml -> [Indx] -> [Fml]
convIndicesToFormulas _ [] = []
convIndicesToFormulas fs (i:is) = (getFml i fs) : (convIndicesToFormulas fs is)

formulaIsOm :: Fml -> Bool
formulaIsOm UnkFml = True
formulaIsOm _ = False

getInvolvedIndicesFromErrIndices :: Sheet Fml -> [Indx] -> [Indx]
getInvolvedIndicesFromErrIndices fs [] = []
getInvolvedIndicesFromErrIndices fs (i:is) = (getIndicesFromFormula (getFml i fs)) ++ (getInvolvedIndicesFromErrIndices fs is)

----- [scott] returns a list of indices involved in the formula
getIndicesFromFormula :: Fml -> [Indx]
getIndicesFromFormula UnkFml = []
getIndicesFromFormula (Inp _) = []
getIndicesFromFormula (Ref idx) = [idx]
getIndicesFromFormula (RefRng rng) = concat (map getIndicesFromFormula rng)
getIndicesFromFormula (Bin _ fml1 fml2) = concat (map getIndicesFromFormula [fml1, fml2])
getIndicesFromFormula (Agg _ rng) = concat (map getIndicesFromFormula rng)
-}
----- SCOTT'S TEST CODE (END) -----

----- ETHAN'S OLD TEST CODE (BEGIN) -----
{-
{-
    A      B      C     D       E
1        Fruit
2  Month Apple   Orange Plum    Total
3    May     8     11    21     *
4   June    75     5     15     /
5   July    30     4   30     +
6          SUM    SUM  SUM      SUM
7

-}

units :: SheetU
units = inferU harvestHeaders harvest

harvestHeaders :: Headers
harvestHeaders = [(b 1,[]),(b 2,[b 1]),(c 2,[b 1]),(d 2,[b 1]),
                  (a 2,[]),(a 3,[a 2]),(a 4,[a 2]),(a 5,[a 2]),
                  (b 3,[a 3,b 2]),(c 3,[a 3,c 2]),(d 3,[a 3,d 2]),
                  (b 4,[a 4,b 2]),(c 4,[a 4,c 2]),(d 4,[a 4,d 2]),
                  (b 5,[a 5,b 2]),(c 5,[a 5,c 2]),(d 5,[a 5,d 2])]

harvest :: Sheet Fml
harvest = Sheet [(b 1,is "Fruit"),
                 (a 2,is "Month"),(b 2,is "Apple"),(c 2,is "Orange"),(d 2,is "Plum"),(e 2,is "Total"),
                 (a 3,is "May"), (b 3, ii 8), (c 3, ii 11),(d 3,ii 21),(e 3,agg Plus [b 3,c 3, d 3]),
                 (a 4,is "June"), (b 4, ii 2), (c 4, ii 4),(d 4,ii 15),(e 4,agg Plus [b 4,c 4, d 4]),
                 (a 5,is "July"),(b 5,ii 5),(c 5, ii 2),(d 5, ii 10), (e 5, Agg Plus [Ref(b 5), Ref(c 5), Ref(d 5)]),
                 (a 6, iu),(a 7,iu), (e 6, agg Plus [b 6,c 6, d 6]), (b 6,agg Plus [ b 3 ,b 4, b 5])
 		 ,(c 6,agg Plus [ c 3,c 4, c 5]),(d 6,agg Plus [d 3, d 4, d 5])]

d7 = foldr1 mO [d3,d4,b4,c3,c4]
b6 = getUnit'(b 6) harvest harvestHeaders
b3 = getUnit' (b 3) harvest harvestHeaders
b4 = getUnit' (b 4) harvest harvestHeaders
b5 = getUnit' (b 5) harvest harvestHeaders
c3 = getUnit' (c 3) harvest harvestHeaders
d3 = getUnit' (d 3) harvest harvestHeaders
c4 = getUnit' (c 4) harvest harvestHeaders
c5 = getUnit' (c 5) harvest harvestHeaders
c6 = getUnit' (c 6) harvest harvestHeaders
d4 = getUnit' (d 4) harvest harvestHeaders
d5 = getUnit' (d 5) harvest harvestHeaders
d6 = getUnit' (d 6) harvest harvestHeaders
e6 = getUnit' (e 6) harvest harvestHeaders
e4 = getUnit' (e 4) harvest harvestHeaders
e5 = getUnit' (e 5) harvest harvestHeaders

hdr = getHeaderUnit harvest harvestHeaders (flipHeader harvestHeaders)
suggestions = genSugg hdr

getUnit':: Indx -> Sheet Fml -> Headers -> Unit
getUnit' x f h = snd $ fromMaybe (a 0,U [[["Error"]]]) (find (\(idx,u) -> idx == x) s)
		where s = drop' $ inferU h f

drop':: SheetU -> [(Indx,Unit)]
drop' (Sheet u) = u
-}
----- ETHAN'S OLD TEST CODE (END) -----
