--
-- UnitErrors.hs -- Unit error types used by Units and FaultLoc
-- Owner -- Scott Andrew
--

module UCheck.UnitErrors where

--------------------------------------------------
-- imports
--------------------------------------------------

import Sheet.Indx
import Sheet.Sheet

import List

--------------------------------------------------
-- unit error types
--------------------------------------------------

type ErrRpt = [ErrSit]

type ErrSit = Cell [ErrDesc]

data ErrDesc = RefErr Indx
             | Omission Indx
             | RngSml Indx Indx
             | RngOfst Indx Indx
             | UnExRef
             | RngLrg Indx Indx
             | SuspectRange Indx Indx
             | UnkErr
             | Temp
             | NoErr
             | FillRng [(Indx,[Indx])]
             | AddRng [Indx]
             | ShrnkRng [Indx]
             | UnkFill
             | ScottTmp [[[String]]]
               deriving(Show,Eq,Ord)

type Color = Int
type ErrorInfo = (Color, String)

refineErrs :: ErrRpt -> ErrRpt
refineErrs es = map combErrs (groupBy (\(i,_) (i',_)->i == i') (sort (concatMap (\(i,eds)->concatMap (refineErr i) eds) es)))

combErrs :: [ErrSit] -> ErrSit
combErrs ess@((i,_):_) = (i,(concatMap (\(_,ed)->ed) ess))

refineErr :: Indx -> ErrDesc -> [ErrSit]
refineErr i (FillRng f) = (map (\(fi,fis)->(fi,[AddRng fis])) f) ++ [(i,[AddRng []])]
refineErr i ed = [(i,[ed])]