module Data.Transform.PropExample where


import Data.Transform.Coupled
import Data.Transform.TwoLevelPF
import Data.Transform.RulesPF
import Data.Transform.Rewriting (many, once, top)

import Data.Map as Map
import Data.Set as Set


exmp = Prod (Map (Tag "||RESERVED||" String) (Prod (Tag "rentStart" String) (Prod (Tag "rentFinish" String) (Prod (Tag "FORMtotaldays" String) (Tag "FORMrent_total" String))))) 
          (Prod (Map (Tag "clientNo" String) (Tag "cName" String)) 
            (TInv (Prod (Map (Tag "ownerNo" String) (Tag "oName" String)) 
              (Map (Tag "propertyNo" String) (Prod (Tag "pAddress" String) (Prod (Tag "rent_per_day" String) (Tag "ownerNo" String))))) inv))
  where
    inv = SetInc typeof (COMP typeof (SET (COMP typeof SND SND)) (COMP typeof RNG SND))
                        (COMP typeof DOM FST)




clientNo = Tag "clientNo" String
cName = Tag "cName" String
propertyNo = Tag "propertyNo" String
rentStart = Tag "rentStart" String
rentFinish = Tag "rentFinish" String
pAddress = Tag "pAddress" String
rent = Tag "rent" String -- Int
ownerNo = Tag "ownerNo" String
oName = Tag "oName" String


client = Map clientNo cName

owner = Map ownerNo oName

rental = Map (Prod clientNo propertyNo) (Prod rentStart rentFinish)

propertyForRent = Map propertyNo (Prod pAddress (Prod rent ownerNo))


prop = Prod owner (TInv (Prod client (TInv (Prod rental propertyForRent) inv1)) inv2)
  where
    inv1 = SetInc typeof (COMP typeof (SET SND) (COMP typeof DOM FST)) 
                         (COMP typeof DOM SND)

    inv2 = SetInc typeof (COMP typeof (SET FST) (COMP typeof DOM (COMP typeof FST SND)))
                         (COMP typeof DOM FST)


