module FDInference where



import List as L
import Maybe
import Types
import Combinators 
import Debug.Trace
import Control.Monad.Trans

--import Synthesize

--infix <|




lks2fds :: Eq b => LKS b -> FDS b-- [String]
lks2fds = concatMap toStr
    where
        toStr (LK cand card qcls cls) = let as = (atts cls) L.\\ (atts qcls)
                                        in if length as /= 0
                                                then [(cand, Atts as)]
                                                else []


-- *************************************** FD Inference ******************

candidates :: LKS b -> [Candidate b]
candidates = map (candidate)

setCardinality :: Int -> LK b -> LK b
setCardinality l (LK a _ q cl) = LK a l q cl





-- |  some inputs may not have FDs. in that case a FD with key being all the att and values empty
--    if some attrs aren't represented in the FDs, a FD with them as key and empty
--    values is also returned. NOTE: this is not performed here since this function
--    returns LKS and not FDS ...
--
--fun :: (Eq a, Eq b, Monad m, Show a) => R a -> Relation b -> Int -> m (LKS a)
fun r rl = do 
                l <- --trace ("R' : " ++ show l1) 
                    funA l0 l1 r (Atts r') rl [] 100
              --mapM putStrLn (displayFD l)
                return l
    where
        l0 = [LK (Atts []) 0 (Atts []) (Atts [])]
        l1 = [LK (Atts [cand]) (count r rl (Atts [cand])) (Atts [cand]) (Atts [cand]) | cand <- (atts r)]
        r' = filter (\at -> not $ isKeyAtt r rl (Atts [at])) (atts r)
      --  fs = filter (\at -> count r rl (Atts at) == count r rl (Atts [])) (atts r)

       

-- need more tests
-- steel have a but: doesn't give keys
--funA :: LKS -> LKS -> R -> R -> R -> [[String]] -> [[String]]
funA _ _ _ _ _ l 0 = return l

funA lk1 [] r r' rl l _ =  do
                    let lk1'_ = -- trace ("lk1'\n" ++ show lk1') $ 
                          computeClosure r r' rl lk1 []
                        lk' = --trace ("lk'\n" ++ show lk') $ 
                          computeQuasiClosure r rl [] lk1'_
                   -- mapM putStrLn $ displayFD lk1'
                    -- mapM putStrLn $ displayFD lk'
                    let lk1' = filter ((/= (length ( rl))).cardinality) lk1'_
                    let lk'' = -- trace ("lk''\n" ++ show lk1') $ 
                          purePrune r rl lk' lk1'
                        lk1'' = generateCandidate r rl lk''
                  --  putStrLn ("lk1''\n" ++ show lk1'') -- putStrLn ("end round 2 \n" )
                   -- mapM putStrLn $ displayFD lk1'
                   -- mapM putStrLn $ displayFD lk1''
                  --  putStrLn "ola"
                    return (l++lk1''++lk'') 

funA lk1 lk r r' rl l n = do
                {-    putStrLn "Lk-1\n"
                    putStrLn $ show lk1
                    putStrLn "\nLk\n"
                    putStrLn $ show lk ++ "\n\n"
 -}
                    let lk1'_ = computeClosure r r' rl lk1 lk
                    let lk' = -- trace ("lk1'\n" ++ show lk1') $ 
                              computeQuasiClosure r rl lk lk1'_
                   -- putStrLn $ "\nlk1'\n" ++ show lk1'

                   -- putStrLn $ "\nlk'\n" ++ show lk'
               --     mapM putStrLn $ displayFD lk1'_
                  -- as chaves sao adicionadas ao lk-1, depois sao mostradas e depois tem de ser eliminadas
                    let lk1' = filter ((/= (length rl)).cardinality) lk1'_
                   -- mapM putStrLn $ displayFD lk'
                    let lk'' = -- trace ("lk'_ - rl \n" ++ show lk1'_ ++ " - " ++ (show $ length rl)
                                  --  ++ "\nlk' - rl \n" ++ show lk1' ++ " - " ++ (show $ length rl)) $ 
                              purePrune r rl lk' lk1'
                    let lk1'' = --trace ("lk''\n" ++ show lk'') $ 
                              generateCandidate r rl lk''
                  --  putStrLn ("lk1''\n" ++ show lk1'') -- $ putStrLn ("end round \n" )
                    funA lk'' lk1'' r r' rl (l++lk1') (n-1)
                    -- funA lk'' lk1'' r r' rl (l++lk1') (n-1)

-- VERY IMPORANOTE ON FUN: in the last line just above if lk1'_ is used then it will return keys
-- if lk1' is used, it doesn't return keys




-- simes ok
displayFD :: (Show b, Eq b) => LKS b -> [String]
displayFD = filter (/=[]).(map toStr)
    where
        toStr (LK cand card qcls cls) = let as = (atts cls) \\ (atts qcls)
                                        in if length as /= 0
                                            then show cand ++ "->" ++ show as   
                                                else []



-- ok
-- 
generateCandidate :: (Eq b, Eq a, Show b) => R b -> Relation a -> LKS b -> LKS b
generateCandidate _ _ [] = []
generateCandidate r rl ((LK cand _ _ _):_) = 
    let c = filter (\l ->   -- cand <| l && 
                          length (atts l) == length (atts cand) + 1)-- && 
                          -- count r rl l /= length rl) -- sao eliminadas depois de mostradas no alg. principal
                (powerset r)
    --in if length (atts cand) == 4 then trace ("\n\ncand: " ++ show cand) (map (\cand -> LK cand (count r rl cand) (Atts []) (Atts [])) c)
      --  else 
      in map (\cand -> LK cand (count r rl cand) (Atts []) (Atts [])) c

-- tests
-- ok



-- receives R, R' the relation, Lk-1, Lk
computeClosure :: (Eq b, Eq a, Show b) => R b -> R b -> Relation a -> LKS b -> LKS b -> LKS b
computeClosure r r' rl lks1 lks = map cCAux lks1
  where      
    cCAux lk1@(LK cand card qclsr clsr) = 
            if not (isKey r rl lk1) 
                then LK cand card qclsr (cCAux2 cand card qclsr (Atts $ (atts r') \\ (atts qclsr)))
                else lk1
              --  else if length (atts cand) == 4 then trace ("\nin compClosure:" ++ show lk1 ++ "\n") lk1 else lk1

    cCAux2 _ _ clsr (Atts []) = clsr     
    cCAux2 cand card clsr (Atts (at:ats)) = 
       --   if fastCount2 lks1 lks (Atts $ (atts cand) `union` [at]) == card
                                  -- vou deixar isto assim mas tenho de corrigir o fastCount
                                 if count r rl (Atts $ (atts cand) `union` [at]) == card
                                      then cCAux2 cand card (Atts $ (atts clsr) `union` [at]) (Atts ats)
                                      else cCAux2 cand card clsr (Atts ats)

-- tests
-- more tests needed
--
-- cc1 lks1 = computeClosure r1 r1 rel1 lks1 lks1


-- | parece bem...
--
fastCount2 :: Eq a => LKS a -> LKS a -> Candidate a -> Int 
fastCount2 lk1 lk cand = case getlk cand lk of
                            Just card -> -- maximum [cardinality l' | l' <- lk1, (candidate l') <| cand] 
                                         trace ("ssss") card
                            Nothing -> trace "zzzz" maximum [cardinality l' | l' <- lk1, (candidate l') <| cand]
  where                            
    getlk cand [] = Nothing
    getlk cand ((LK c card _ _):r) | c == cand = Just card
                                   | otherwise = getlk cand r


l1 = LK{candidate = Atts $ map Att [1, 2, 3], cardinality = 6, quasiClosure = Atts [], closure = Atts []}
l2 = LK { candidate = Atts $ map Att [1,2], cardinality = 3, quasiClosure = Atts [], closure = Atts [] }
l3 = LK { candidate = Atts $ map Att [7,3], cardinality = 3, quasiClosure = Atts [], closure = Atts []}

lks1' = [l1, l2, l3]

-- 
computeQuasiClosure :: (Eq b, Eq a) => R b -> Relation a -> LKS b -> LKS b -> LKS b 
computeQuasiClosure r rl lks lks1 = map (cQCAux r lks1) lks
    where
        cQCAux r lks1 lk@(LK cand card qclsr clsr) = 
            let ss = filter (`elem` (candidates lks1)) (powerset cand)
            in LK cand card (Atts (foldr union [] ((atts cand):(map (atts.(compClosure rl r)) ss)))) 
                  (clsr1 lk clsr)
        
        clsr1 lk clsr = if isKey r rl lk then r else clsr -- trace ("\nis key\n") r else clsr

        -- definition 7
        compClosure :: (Eq b, Eq a) => Relation a -> R b -> Attributes b -> Attributes b
        compClosure rl r x = Atts $ (atts x) `union` 
                             [a | a <- (atts r) \\ (atts x), count r rl x == count r rl (Atts ((atts x) `union` [a]))]

-- tests
-- ok
--
cqc1 = computeQuasiClosure r1 rel1 lks1 lks1



-- ok
-- receives L_k, L_k1
purePrune :: (Eq b, Eq a) => R b -> Relation a -> LKS b -> LKS b -> LKS b
purePrune _ _ [] _ = []
purePrune r rl lks lks1 = filter (delPP lks1) lks
    where
        delPP lks1 (LK cand card qclsr clsr) = let ss = powerset cand 
                                                   cands = candidates lks1
                                                   final = filter (`elem` cands) ss
                                               in and $ map (\final -> count r rl final /= card)
                                                                        final
-- tests
-- ok

pp1 = purePrune r1 rel1 lks1 lks1

                                    
                                    

-- algorithm 7
-- tem um bug!!!!!!!!!!!!!
-- instead of a candidate this should receive a LK
-- receives L_k-1, L_k, l.candidate
--
fastCount :: (Eq b) => LKS b -> LKS b -> Candidate b -> Int
fastCount lks1 lks l = if l `elem` (candidates lks)
                                then
                                    let Just ind = elemIndex l (candidates lks)
                                    in cardinality $ lks !! ind
                                else
                                    let l'candidates = filter ((<| l).candidate) lks1
                                    in maximum $ map cardinality l'candidates 

-- tests
-- ok
--
fc1 = fastCount lks1 lks1 (Atts $ map Att [1, 2, 3])


fastCount' :: (Ord b, Eq a) => R b -> Relation a -> [R b] -> LKS b -> LK b -> Int
fastCount' r rl fs lks (LK cand card qc cl) =   
    if cand `elem` (candidates lks)
        then
            card
        else
            maximum [count r rl l' | l' <- powerset cand, l' <| cand]


lk1 = LK { candidate = Atts $ map Att [1, 2, 3],
           cardinality = 6,
           quasiClosure = Atts [],
           closure = Atts [] }

lk2 = LK { candidate = Atts $ map Att [2, 3],
           cardinality = 5,
           quasiClosure = Atts [],
           closure = Atts [] }





lk3 = LK { candidate = Atts $ map Att [1, 3],
           cardinality = 6,
           quasiClosure = Atts [],
           closure = Atts [] }


lks1 = [lk1, lk2, lk3]

r1 = Atts $ map Att [1, 2, 3]

rel1 = [ ["a1", "b1", "c1"],
         ["a2", "b1", "c2"],
         ["a1", "b2", "c3"],
         ["a3", "b3", "c4"],
         ["a2", "b3", "c4"],
         ["a3", "b3", "c3"] ]



-- simes ok
-- conta o numero de valores distinctos dos atributos dados na relacao 
-- isto é mt pesado, tem de estar bem optimizado
-- um bocadinho melhor que count2
-- sem o nub fica instantaneo, com ele demora 10s
count :: (Eq b, Eq a) => R b -> Relation a -> Attributes b -> Int
count (Atts r) rl (Atts a) = let inds = mapMaybe (flip elemIndex r) a
                             in length $ nub $ filter (/=[]) $ transProjection rl inds

--                   proj = transpose $ map (projection rl) inds
--               in length $ nub proj

--count2 :: Eq a => R -> Relation a -> Attributes -> Int
count2 r rl a = let inds = mapMaybe (flip elemIndex r) a
                    proj = transpose $ map (projection rl) inds
                in length $ nub proj

count3 r rl a = transProjection rl $ mapMaybe (flip elemIndex r) a

transProjection :: Relation a -> [Int] -> [[a]]
transProjection [] _ = []
transProjection (h:t) l = (map (h !!) l) : (transProjection t l)


projection :: Relation a -> Int -> [a]
projection [] _ = []
projection (h:t) p = (h !! p):(projection t p)



powerset :: Attributes l -> [Attributes l]
powerset (Atts l) = map Atts (powerset' l)

powerset'       :: [a] -> [[a]]
powerset' []     = [[]]
powerset' (x:xs) = xss /\/ map (x:) xss
    where 
    xss = powerset' xs

(/\/)        :: [a] -> [a] -> [a]
[]     /\/ ys = ys
(x:xs) /\/ ys = x : (ys /\/ xs)


-- X key if X -> R
-- Lemma 1
--
isKey :: (Eq c, Eq b) => R c -> Relation b -> LK a -> Bool
isKey r rl lk = cardinality lk == count r rl r


isKeyAtt :: (Eq b, Eq a) => R b -> Relation a -> Attributes b -> Bool
isKeyAtt r rl lk = count r rl lk == count r rl r

