module TFile where


-- module to read and write relations to file

import Types


toFile :: (Show b, Show a) => FDS b -> [Relation a] -> FilePath -> IO ()
toFile fds rls f 
  =
    let str = concatMap (\rl -> showz rl ++ "\n") (zip fds rls)
    in writeFile f str
  where
    showz (h, j) = showf h ++ "\n" ++ showe j ++ "\n" 

    showf (Atts a, Atts c) = show $ map att (a ++ c)

    showe [] = []
    showe (h:t) = showg h ++ "\n" ++ showe t

    showg [] = []
    showg (h:t) = show h ++ "," ++ showg t


-- the idea is to print the columns side by side
--
toFile' :: (Eq a, Show b, Show a) => FDS b -> [Relation a] -> FilePath -> IO ()
toFile' fds rls f 
  =
    let str = showz fds ++ "\n" ++ showp (map head rls) rls
    in writeFile f str
  where
  -- print atts
    showz [] = []
    showz (h:t) = showf h ++ ",," ++ showz t

    showf (Atts a, Atts c) = show $ map att (a ++ c)

    showp hd al = if (concat al == []) 
                  then []  
                  else (showe hd (map (\x -> if x == [] 
                                                 then []
                                                 else head x) al)) ++ "\n" ++ 
                              showp hd (map (\x -> if x == [] 
                                                                then []
                                                                else tail x) al)

  -- print each line
    showe _ [] = []
    showe (hd:hds) (h:t) = if h == []
                            then concat (replicate (length hd) ",") ++ "," ++ showe hds t
                            else showg h ++ ",," ++ showe hds t

    showg [x] = show x
    showg (h:t) = show h ++ "," ++ showg t    
