module Main where


import Data.Maybe
import System.IO.Unsafe
import System 
import IO
import Debug.Trace

import HaExcel.HaExcel

import WASH.CGI.CGI hiding (head, map)
import WASH.CGI.CGIInternals


main :: IO ()
main = do
    (inf, outf) <-  fix2Args
    o <- if outf=="-" then return stdout else openFile outf WriteMode
    ss2SQL inf outf

fix2Args :: IO (String,String)
fix2Args = do
  args <- getArgs
  case length args of
  --  0 -> return ("-",     "-")
    1 -> return (args!!0, "-")
    2 -> return (args!!0, args!!1)
    _ -> do prog <- getProgName
            putStrLn ("Usage: "++prog++" [InGnumericFile] [OutSQLFile]")
            exitFailure




-- this main produces a web page
{-
main :: IO ()
main = run mainCGI

mainCGI = standardQuery "" $ do 
              doc_head
              doc_body

doc_head = head [title $ text "HaExcel"]

bgcolor = "background-color" :=: "#C0C0C0"
padd = "padding" :=: "50px"
align = "text-align" :=: "justify"

talign = "text-align" :=: "center"
width = "width" :=: "850px"
left = "margin-left" :=: "auto"
right = "margin-right" :=: "auto"

battrs = width :^: left :^: right

tattrs = bgcolor :^: padd :^: align

doc_body = using battrs body $ do
  using tattrs table $ tr $ td $   
                      do  h1 $ text "HaExcel"
                          p str1
                          p $ a (attr "href" gnumeric ## img (attr "src" image)) ## attr "align" "center"
                          p str2
                          p str3
                          p str4
                          p rdb
                          p $ text str5 ## a (attr "href" gnumeric ## text "here") ## text "."
                          p $ text ""
                          fil <- 
                              p (do text "Choose a spreadsheet file "
                                    fileInputField (attr "size" "30")
                                )
                          submit fil page2 (attr "value" "Transform")
                          signature "Jacome Cunha" "mailto:jacome@di.uminho.pt"

signature url name = hr empty ## address (hlink (URL name) (text url))
    

image = "../prop.jpg"

gnumeric = "../prop.gnumeric"

str1 = 
  text "The HaExcel is a framework to manipulate, transform and query spreadsheets. It is implemented in the Haskell functional programming language and it consists of the following parts:" ##
  br empty ##
  ul 
    (li (text "A generic/reusable library to map spreadsheets into relational database models and back." ##
      br empty ##
      br empty ##
      text "The library contains an algebraic data type to model a (generic) spreadsheet and functions to transform it into a relational model. Such functions implement the refinement rules introduced in the paper \"Type-Safe Two Level Transformations\". The library includes also functions to generate the SQL code that creates the corresponding database (in the 3NF).") ##
      br empty ##
    (li (text "A frontend to read spreadsheets in the Excel and Gnumeric format (XML-based).")) ##
      br empty ##
    (li (text "Two tools: A batch and a online tool that allow the users to read, transform and query spreadsheets."))) ##
   br empty ##
  text "This webpage shows the online tool." ##
  br empty ##
  br empty ##
  text "Suppose that you have the following spreadsheet representing a house renting system:" 

str2 = 
  text "And you want to know all the property's owners that have houses in 'Novar Dr.' with a rent above 400. Altough in this simple example it is not difficult to answer the query by just looking at the spreasheet, this is not the case if we consider real applications/spreadsheet." ##
  br empty ##
  br empty ##
  text "After transforming this spreadsheet into a relational database, this task becomes very simple: The following SQL query finds the result we want."
  
str3 = 
  text "select oName from rents where pAddress like 'Novar Dr.' and rent > 400"

str4 = 
  text "The spreadsheet is automatically transformed by our framework into the following tables in the 3NF (note that primary keys are underlined)."

str5 = "To transform your own spreadsheets use the form below. The above spreadsheet example can be downloaded "

 
page2 fil =
    let box = genSQL $ unsafePerformIO $ ss2boxes (fileReferenceName $ fromJust $ ifValue fil) 
    in standardQuery "SQL" $ tables 0 box 
  where
    tables n [t] =  h2 (text $ "Spreadsheet table transformed into: ") ## (table t)
    tables n (h:t) = h2 (text $ "Spreadsheet table transformed into: ") ## (table h) ## tables (n+1) t

    table [t] = p (text t)
    table (h:t) = p (text h) ## table t

rdb = (text "rentDates (" ## u (text "rentStart, rentFinish") ## text ")") ## br empty ##
      (text "clients (" ## u (text "clientNo") ## text ", cName)") ## br empty ##
      (text "owners (" ## u (text "ownerNo") ## text ", oName)") ## br empty ##
      (text "properties (" ## u (text "propertyNo") ## text ", pAddress, rent, oName)")
-}
